/*
* Copyright 2001-2002, 2010 pilot <pilot@monkey.org>
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
* 3. The name of the author may not be used to endorse or promote products
*    derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* arirang header file */
#ifndef _ARIRANG_H_
#define _ARIRANG_H_ 

#define TITLE   "Don't tell your webserver free from blackhats"
#define PATH_CLEAR  "/usr/bin/clear"

#define NETCRAFT    "uptime.netcraft.com"
#define NETCRAFT_FINGER "/up/graph/?site="
#define HTML_FILTER "<>b"
#define WAIT_TIME 5

#define SEND_URI    "GET / HTTP/1.0"
#define SEND_OPTION "OPTIONS / HTTP/1.0"
#define HTTP_VER_1  " HTTP/1.0"
#define HTTP_VER_1_1    " HTTP/1.1"

#define USED_IP_RANGE   "/tmp/ip_range.arirang"

#define SCANRULE_MSG1   "starting scanrule"
#define SCANRULE_MSG2   "end check scanrule"

void scanrule(char *, unsigned int, char *, unsigned short int);
void scanruleP(char *, unsigned int, char *, unsigned short int, unsigned short int);
void scanruleWP(unsigned long, unsigned int, char *, unsigned short int, unsigned short int);

int recvtimeout(int, char *, int, int);
int recvtimeoutr(int, char *, int, int);

void grabhead(char *, unsigned int, short int);
void grabheadW(unsigned long, unsigned int, unsigned short int, short int);
void osdetect(char *);
void scrview(void);
void usage(void);

#if !(defined(__OpenBSD__) || defined(__FreeBSD__) || defined(__NetBSD__) || defined(__APPLE__))
void    timegrab(int sig);   
#endif

void        htmlhead(char *);
void        htmltail(char *);

#endif /* _ARIRANG_H_ */
